/***************************************************************************
                          menu.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "menu.h"
#include "resources.h"
#include "timer.h"
#include "mainscreen.h"
#include "game.h"
#include "editor.h"
#include "gui.h"
#include "config.h"

Menu::Menu(Auriferous* _app)
{
	app=_app;
	timer=new Timer;
	frame_count=0;
	fps=0;
}
Menu::~Menu()
{
}
void Menu::start()
{
	CL_MouseCursor::set_cursor(Resources::Cursor());
	main=new Mainscreen(app);

	while (!main->quited())
	{
		CL_Display::clear_display();
		main->actshowall();
		actshowgui();

		if(Config::get_fps()==true)
		draw_fps();

		CL_Display::flip_display();			
		CL_System::keep_alive();
}
}
void Menu::actshowgui()
{
  it = guiobjs.begin();
  while (it!=guiobjs.end())
  {
    /* erase invalidates the iterator, so make a copy to operate on
       and increment it beforehand */
    list<Gui*>::iterator g=it;
    it++;
    if((*g)->Delete_Me()==true)
    {
      guiobjs.erase(g);
      guiobjs.sort();
    }
  }
  for(it = guiobjs.begin(); it!=guiobjs.end(); ++it)
  {
    Gui *g=*it;

    if(!g->get_disabled() && !g->get_frozen())
    g->act();
  }
}
void Menu::freeze_gui(bool fr)
{
  for(it = guiobjs.begin(); it!=guiobjs.end(); ++it)
  {
    Gui* g=*it;

      if(fr==true)
	    g->set_frozen(true);
      else
      {
        if(g->get_frozen()==false)
		    g->set_Delete_Me();
		    else
		    g->set_frozen(false);
      }
    }
}
void Menu::disable_ms(bool fr)
{
    for(it = guiobjs.begin(); it!=guiobjs.end(); ++it)
    {
      Gui* g=*it;

      if(fr==true)
		  g->set_disabled(true);
      else
      {
        if(g->get_disabled()==false)
		    g->set_Delete_Me();
		    else
		    g->set_disabled(false);
      }
    }
}
void Menu::draw_fps()
{
	frame_count++;

	if(timer->time_elapsed()>0.1f)
	{
		fps=(int)(frame_count/timer->time_elapsed());
		frame_count=0;
		timer->reset();
	}
	
	Resources::Gfont()->print_left(0, 0, (CL_String)(fps)+" fps");
}